(document:surround "/std/frame")
(po-domain "alterator-chainmail")
;; UI

(gridbox
  columns "0;60;40"
  margin 20

  (label name "domain" align "right" text (_ "Domain:"))
  (edit name "domain")(spacer)

  (spacer)(label text-wrap #t
         text (small (_ "Domain name should follows RFC 1035")))(spacer)
  (spacer)(label text-wrap #t
         text (small (_ "Domain name should contains one or more labels separated by dots.")))(spacer)
  (spacer)(label text-wrap #t
         text (small (_ "Labels must start with a latin letter (in upper and lower case), end with a letter or digit, and have as interior characters only letters, digits, and hyphen.")) )(spacer)
  (spacer)(label text-wrap #t
         text (small (_ "Labels must be 63 characters or less.")))(spacer)
  (spacer)(label text-wrap #t
         text (small (_ "Domain should not has labels named 'localhost', 'localdomain' and 'local'. They are reserved for internal purposes.")))(spacer)
  (spacer)(label text-wrap #t
         text (small (_ "Examples: domain, school-33, department.company")))(spacer)

  (label colspan 2)(spacer)
  (separator colspan 3)
  (label text (_ "Select external interfaces:") colspan 3)
  (checklistbox name "external_ifaces" colspan 3))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Functions

;;; iptables

(define *net-iptables-data* (make-cell ""))

;; TODO: IP version shouldn't be hardcoded
(define (read-iptables)
  (form-update-enum "external_ifaces" (woo-list "/net-iptables/ifaces" 'ipv 4))
  (let ((data (woo-read-first "/net-iptables" 'ipv 4)))
	(form-update-value-list '("external_ifaces") data)
	(cell-set! *net-iptables-data* data)))

(define (commit-iptables)
  (let ((data (cell-ref *net-iptables-data*)))
	(woo-write "/net-iptables"
			   'language (form-value "language")
			   'ipv 4
			   'status #t
			   'mode (woo-get-option data 'mode)
			   'opened_services (woo-get-option data 'opened_services)
			   'opened_tcp_ports (woo-get-option data 'opened_tcp_ports)
			   'opened_udp_ports (woo-get-option data 'opened_udp_ports)
			   'external_ifaces (or (form-value "external_ifaces") ""))))

;;; domain
(define (commit-domain)
  (let ((domain (form-value "domain")))
	(woo-write "/net-domain"
			   'master #t
			   'domain domain
			   'language (form-value "language"))))

;;; common
(define (commit)
  (catch/message
    (lambda()
      (commit-iptables)
      (commit-domain))))

(define (ui-init)
    (form-update-value "domain" "testdomain.ru")
    (read-iptables))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(document:root
    (when loaded
	  (ui-init)))

(frame:on-next (lambda() (or (commit) 'cancel)))
